from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_prediction_period import PoolPredictionPeriod
from ..models.prediction_service_get_pools_response_200_predictions_item_values_item_ahead import (
    PredictionService_GetPoolsResponse_200PredictionsItemValuesItemAhead,
)
from ..types import UNSET, Unset

T = TypeVar(
    "T", bound="PredictionService_GetPoolsResponse_200PredictionsItemValuesItem"
)


@attr.s(auto_attribs=True)
class PredictionService_GetPoolsResponse_200PredictionsItemValuesItem:
    """  """

    ahead: Union[
        Unset, PredictionService_GetPoolsResponse_200PredictionsItemValuesItemAhead
    ] = PredictionService_GetPoolsResponse_200PredictionsItemValuesItemAhead.NONE
    cpr: Union[Unset, float] = UNSET
    period: Union[PoolPredictionPeriod, Unset] = UNSET
    smm: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        ahead: Union[
            Unset, PredictionService_GetPoolsResponse_200PredictionsItemValuesItemAhead
        ] = UNSET
        if not isinstance(self.ahead, Unset):
            ahead = self.ahead

        cpr = self.cpr
        period: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.period, Unset):
            period = self.period.to_dict()

        smm = self.smm

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if ahead is not UNSET:
            field_dict["ahead"] = ahead
        if cpr is not UNSET:
            field_dict["cpr"] = cpr
        if period is not UNSET:
            field_dict["period"] = period
        if smm is not UNSET:
            field_dict["smm"] = smm

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        ahead = None
        _ahead = d.pop("ahead", UNSET)
        if _ahead is not None and _ahead is not UNSET:
            ahead = (
                PredictionService_GetPoolsResponse_200PredictionsItemValuesItemAhead(
                    _ahead
                )
            )

        cpr = d.pop("cpr", UNSET)

        period: Union[PoolPredictionPeriod, Unset] = UNSET
        _period = d.pop("period", UNSET)
        if not isinstance(_period, Unset):
            period = PoolPredictionPeriod.from_dict(cast(Dict[str, Any], _period))

        smm = d.pop("smm", UNSET)

        prediction_service_get_pools_response_200_predictions_item_values_item = cls(
            ahead=ahead,
            cpr=cpr,
            period=period,
            smm=smm,
        )

        prediction_service_get_pools_response_200_predictions_item_values_item.additional_properties = (
            d
        )
        return prediction_service_get_pools_response_200_predictions_item_values_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
